#include <windows.h>
#include <stdio.h>


/* O[oϐ */
HANDLE g_ahSerial[4] = {NULL, NULL, NULL, NULL};


/* DCB\̂̏ */
BOOL InitDCB(int nPortNumber)
{
    DCB dcb;

    dcb.BaudRate            = 9600;
    dcb.fParity             = FALSE;
    dcb.Parity              = NOPARITY;
    dcb.ByteSize            = 8;
    dcb.StopBits            = ONESTOPBIT;
    dcb.fOutxCtsFlow        = FALSE;
    dcb.fOutxDsrFlow        = FALSE;
    dcb.fDtrControl         = DTR_CONTROL_ENABLE;
    dcb.fRtsControl         = RTS_CONTROL_ENABLE;
    dcb.fDsrSensitivity     = FALSE;
    dcb.fOutX               = FALSE;
    dcb.fInX                = FALSE;
    dcb.fTXContinueOnXoff   = TRUE;
    dcb.XonLim              = 2048;
    dcb.XoffLim             = 2048;
    dcb.XonChar             = 0x11;
    dcb.XoffChar            = 0x13;
    dcb.fBinary             = TRUE;
    dcb.fNull               = FALSE;
    dcb.fAbortOnError       = TRUE;
    dcb.fErrorChar          = FALSE;
    dcb.ErrorChar           = 0x00;
    dcb.EofChar             = 0x03;
    dcb.EvtChar             = 0x02;
    dcb.DCBlength           = sizeof(DCB);
    dcb.wReserved           = 0;

    if(!SetCommState(g_ahSerial[nPortNumber - 1], &dcb))
    {
        g_ahSerial[nPortNumber - 1] = NULL;
        return FALSE;
    }

    return TRUE;
}


/* COMMTIMEOUTS\̂ */
BOOL InitCommTimeOuts(nPortNumber)
{
    COMMTIMEOUTS cto;

    cto.ReadIntervalTimeout         = 500;
    cto.ReadTotalTimeoutMultiplier  = 0;
    cto.ReadTotalTimeoutConstant    = 0;
    cto.WriteTotalTimeoutMultiplier = 0;
    cto.WriteTotalTimeoutConstant   = 0;

    if(!SetCommTimeouts(g_ahSerial[nPortNumber - 1], &cto))
    {
        g_ahSerial[nPortNumber - 1] = NULL;
        return FALSE;
    }

    return TRUE;
}


/* VA|[gJ */
BOOL SerialOpenPort(int nPortNumber)
{
    char szSerial[256];

    if(g_ahSerial[nPortNumber - 1] != NULL)
    {
        return FALSE;
    }

    sprintf(szSerial, "COM%d", nPortNumber);
    g_ahSerial[nPortNumber - 1] = CreateFile(
        szSerial,
        GENERIC_READ | GENERIC_WRITE,
        0,
        NULL,
        OPEN_EXISTING,
        FILE_ATTRIBUTE_NORMAL,
        NULL
        );

    if(g_ahSerial[nPortNumber - 1] == INVALID_HANDLE_VALUE)
    {
        g_ahSerial[nPortNumber - 1] = NULL;
        return FALSE;
    }

    if(!InitDCB(nPortNumber))
    {
        return FALSE;
    }

    if(!InitCommTimeOuts(nPortNumber))
    {
        return FALSE;
    }

    return TRUE;
}


/* VA|[g */
BOOL SerialClosePort(int nPortNumber)
{
    BOOL bResult;

    bResult = CloseHandle(g_ahSerial[nPortNumber - 1]);
    g_ahSerial[nPortNumber - 1] = NULL;

    return bResult;
}


/* VA|[gɃf[^𑗐M */
BOOL SerialWriteStrings(int nPortNumber, char *szWrite)
{
    DWORD dwWrittenBytes;

    return WriteFile(g_ahSerial[nPortNumber - 1], (char *)szWrite, strlen(szWrite), &dwWrittenBytes, NULL);
}


/* VA|[gɃf[^M */
BOOL SerialReadStrings(int nPortNumber, char *szRead)
{
    COMSTAT ComStat;
    DWORD   dwError;
    DWORD   dwReadBytes;
    char    szReadBuffer[256];
    BOOL    bResult;
    int     nCount;

    for(nCount = 0; nCount < 256; nCount++)
    {
        szReadBuffer[nCount] = '\0';
    }

    ClearCommError(g_ahSerial[nPortNumber - 1], &dwError, &ComStat);
    bResult = ReadFile(g_ahSerial[nPortNumber - 1], (char *)szReadBuffer, ComStat.cbInQue, &dwReadBytes, NULL);
    strcpy(szRead, szReadBuffer);

    return bResult;
}


/* obt@NA */
BOOL SerialClearBuffer(int nPortNumber)
{
    return PurgeComm(g_ahSerial[nPortNumber - 1], PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
}